#ifndef SFACE_H_
#define SFACE_H_


#include "CNode.h"
#include <vector>
#include <iostream>


/* 
The faces of cube cooresponding to the node.
For a 2-cube, there are nine possible faces.
Indexing the faces proceeds as follows
  the first element is the single 2-cell
  the next elements are the 1-cells, ordered counter clockwise, starting with the bottom edge
  The verticies are ordered as follows:: (0,0) ; (0,1) ; (1,0) ; (1,1) 
*/
struct SFace{
  std::vector< unsigned int > path_;
  CNode * pt_node_;
  int face_number_; // This will be later changed to the type """ std::vector< unsigned int >. """
  public:
    int BirthTime( void){   /* This could very likely throw seg-faults */
      return (*pt_node_).Check_Birth(face_number_);
    };
    int ExportOrder( void ){ /* This could very likely throw seg-faults */
      return (*pt_node_).Check_Export(face_number_);
    };
    bool Check_Cell( void ){ /* This could very likely throw seg-faults */  // Determines if the cell is in the complex 
      return (*pt_node_).Check_Cell(face_number_);
    };
    void DefineExportOrder( int export_index ){ /* This could very likely throw seg-faults */
      (*pt_node_).Set_Export(face_number_, export_index );
    };
    void DefineBirthTime( int birth_time ){   /* This could very likely throw seg-faults */
      (*pt_node_).Set_Birth(face_number_ , birth_time );
    };
	/* The Delete function removes the given face from the complex */
    void Delete( void){   /* This could very likely throw seg-faults  */
      (*pt_node_).delete_face(face_number_);
    };
};

#endif /* SFACE_H_ */
